sampler2D img : register(s0);
sampler2D backy : register(s1);

float rAlpha;
int flipX;
int flipY;
float wScale;
float wMag;
float wCycle;
float pi = 3.14159265;

float4 ps_main(in float2 texCoord : TEXCOORD0) : COLOR0	{
float displace = 0.5*wMag*sin(((texCoord.x*flipY)+(texCoord.y*flipX)+(wCycle/wScale)) * 2*pi* wScale);
rAlpha = rAlpha/255.0;
float2 rplCoord = float2(texCoord.x+(displace*flipX),texCoord.y+(displace*flipY));
float4 inColor = tex2D( img, rplCoord);
float4 backyColor = tex2D( backy, float2((texCoord.x-((0.5-displace)*flipX))*(1.0-(flipX*2.0))+((0.5-displace)*flipX),(texCoord.y-((0.5-displace)*flipY))*(1.0-(flipY*2.0))+((0.5-displace)*flipY)));

return float4( (inColor.rgb*(1.0-rAlpha))+(backyColor.rgb*rAlpha), inColor.a );
}

technique tech_main	{ pass P0 { PixelShader = compile ps_2_0 ps_main(); }  }